/// <reference types="node" />
/// <reference types="node" />
import { EventEmitter } from 'events';
import fs from 'fs';
import { Archive, BaseArchive } from './StreamArchive';
declare type EntryDict = {
    [file: string]: FolderEntry;
};
export declare type FolderEntry = {
    path: string;
    stat: fs.Stats;
    name: string;
    relative_path: string;
};
export declare class FolderArchive implements BaseArchive<FolderEntry> {
    protected _ready: Promise<void>;
    protected root_dir: string;
    protected entries: EntryDict;
    events: EventEmitter;
    constructor(archive: string | FolderArchive);
    protected getEntries(from_directory: string): Promise<EntryDict>;
    dir(dir_name: string): FolderArchive;
    has(name: string): boolean;
    search(query: RegExp): FolderEntry[];
    searchDir(query: RegExp): FolderEntry[];
    ready(): Promise<void>;
    ls(current_dir_only?: boolean): {
        [name: string]: FolderEntry;
    };
    get(name: string, type?: "text" | "arraybuffer" | "blob", parse_auto?: boolean): Promise<any>;
    read(file: FolderEntry, type?: "text" | "arraybuffer" | "blob", parse_auto?: boolean): Promise<any>;
    fromFile(name: string | FolderEntry): Promise<Archive>;
    protected get files(): EntryDict;
    protected get dirs(): EntryDict;
    protected ltrim(name: string, left_str: string): string;
}
export {};
